import 'package:flutter/material.dart';
import '../widgets/DataTableMySqlDemo/Oficina.dart';
import '../widgets/DataTableMySqlDemo/Services.dart';
import 'dart:async';
import '../widgets/functions.dart';

class VerOficinas extends StatefulWidget{
  VerOficinas() : super();
  final String title = 'Oficinas';
  @override
  State<StatefulWidget> viewOficinas() {
    //no se que hago, quizas no lo necesite
    return null;
  }
  _VerOficinasState createState() => _VerOficinasState();
}

class _VerOficinasState extends State<VerOficinas>{
  List<Oficina> _oficinas;
  List<Oficina> _filterOficinas;
  GlobalKey<ScaffoldState> _scaffoldKey;
  TextEditingController _nameController;//
  Oficina _selectOficina;
  bool _isUpdateing;

  @override
  void initState() {
    super.initState();
    _oficinas = [];
    // _filterOficinas = [];
    _isUpdateing = false;
    _scaffoldKey = GlobalKey();
    _nameController = TextEditingController();
    _getOficinas();
  }

  _getOficinas() {

    return _oficinas;
  }


  @override
  Widget build(BuildContext context){
    Services.getOficinas().then((Oficinas) {
      setState(() {
        _oficinas = Oficinas;
        //print(_oficinas);
        //print("Length ${Oficinas.length}");
      });

    });
    List<Oficina> lista =  _oficinas;
    return Scaffold(
      key: _scaffoldKey,
      appBar: AppBar(
        title: Text('Oficinas'),
        centerTitle: true,
        backgroundColor: Colors.red[300],

      ),
      body: ListView.builder(
        itemCount: lista.length,
        itemBuilder: (context, index){
          return Card(
              color: Colors.red[300],
              child: ListTile(
            onTap: () {
              Navigator.pushNamed(context, "/ver/oficina", arguments:{
                'id' : lista[index].id,
              });
            },
            title: Text(lista[index].name),
          )
          );
        }
      ),
    );
  }
}
