import 'package:fast_med_flutter/routes/home.dart';
import 'package:fast_med_flutter/routes/ver_oficinas.dart';
import 'package:fast_med_flutter/routes/ver_oficina.dart';
import 'package:fast_med_flutter/routes/calendario.dart';
import 'package:fast_med_flutter/routes/main.dart';
import 'package:fast_med_flutter/routes/register.dart';
import 'package:fast_med_flutter/routes/welcome.dart';
import 'package:fast_med_flutter/routes/album.dart';
import 'package:flutter/material.dart';
import 'package:fast_med_flutter/routes/especialidades.dart';
import 'routes/translation.dart';

void main() => runApp(MaterialApp(
    initialRoute: '/welcome',
    routes: {
      '/home': (context) => Home(),
      '/verOficinas': (context) => VerOficinas(),
      '/ver/oficina': (context) => VerOficina(),
      '/calendario': (context) => Calendario(),
      '/welcome': (context) => WelcomePage(),
      '/register': (context) => RegisterPage(),
      '/MyApp': (context) => MyApp(),
      '/album': (context) => album(),
      '/especialidades': (context) => especialidades(),
      '/translation': (context) => translation(),

    }
));