
import 'package:flutter_login/flutter_login.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'register.dart';
import 'welcome.dart';
import 'profileinfo.dart';
import 'appointments.dart';
import 'package:http/http.dart' as http;
import 'OfficeScreen.dart';
import 'Offices.dart';
import 'package:fast_med_flutter/routes/home.dart';


class NavigationPage extends StatefulWidget{

  NavigationPage({Key key, this.title}) : super(key: key);
  final String title;

  @override
  _NavigationPageState createState() => _NavigationPageState();
}

class _NavigationPageState extends State<NavigationPage>{


  int _selectedIndex = 0;

  static const TextStyle optionStyle = TextStyle(fontSize: 30, fontWeight: FontWeight.bold);

  final _pageOptions = [
    OfficesScreen(),
    ProfilePage(),
    Home()
  ];

  // static const List<Navigator> _widgetOptions = <Navigator>[
  // //   Navigator.push(
  // // context, MaterialPageRoute(builder: (context) => ProfilePage()));
  // ];


  // void _onItemTapped(int index) {
  //   setState(() {
  //     _selectedIndex = index;
  //   });
  // }
  @override
  Widget build(BuildContext context) {
    final height = MediaQuery.of(context).size.height;
    return Scaffold(
      // appBar: AppBar(
      //   title: Text("Title"),
      // ),
      body:  _pageOptions[_selectedIndex],
      bottomNavigationBar: BottomNavigationBar(
        onTap: (int index){
          setState(() {
            _selectedIndex = index;
          });
        },
          selectedItemColor: Colors.red[800],
        currentIndex: _selectedIndex,
        // onTap: ,
        // currentIndex: ,
        // selectedItemColor: Colors.red, onTap: ,
        //

        items: [
          BottomNavigationBarItem(icon: Icon(Icons.medical_services),
              label: 'FastMed'),
          BottomNavigationBarItem(icon: Icon(Icons.person_rounded),
              label: 'Profile'),
          BottomNavigationBarItem(icon: Icon(Icons.event_note_rounded),
              label: 'Ver Mas')
        ],

      ),
      // body: Container(
      //
      // ),
    );
    // TODO: implement build
    throw UnimplementedError();
  }


}
